import SingletonBase from './base/Singleton';
import { EventType } from './EventEnum';
import { Callback, Callback1, Callback2, Callback3, Callback4 } from './Callback';
import { IBrowserWindow } from './EventInterface';
export default class EventManager extends SingletonBase {
    private _listener;
    private _windows;
    mainInit(windows: IBrowserWindow[]): void;
    rendererInit(): void;
    private _addEventListener;
    private _removeEventListener;
    addEventListener(type: EventType, cb: Callback): void;
    addEventListener<Arg1>(type: EventType, cb: Callback1<Arg1>): void;
    addEventListener<Arg1, Arg2>(type: EventType, cb: Callback2<Arg1, Arg2>): void;
    addEventListener<Arg1, Arg2, Arg3>(type: EventType, cb: Callback3<Arg1, Arg2, Arg3>): void;
    addEventListener<Arg1, Arg2, Arg3, Arg4>(type: EventType, cb: Callback4<Arg1, Arg2, Arg3, Arg4>): void;
    removeEventListener(type: EventType, cb: Callback): void;
    removeEventListener<Arg1>(type: EventType, cb: Callback1<Arg1>): void;
    removeEventListener<Arg1, Arg2>(type: EventType, cb: Callback2<Arg1, Arg2>): void;
    removeEventListener<Arg1, Arg2, Arg3>(type: EventType, cb: Callback3<Arg1, Arg2, Arg3>): void;
    removeEventListener<Arg1, Arg2, Arg3, Arg4>(type: EventType, cb: Callback4<Arg1, Arg2, Arg3, Arg4>): void;
    broadcast(type: EventType, arg1?: undefined, arg2?: undefined, arg3?: undefined, arg4?: undefined, arg5?: undefined): void;
    broadcast<Arg1>(type: EventType, arg1: Arg1, arg2?: undefined, arg3?: undefined, arg4?: undefined, arg5?: undefined): void;
    broadcast<Arg1, Arg2>(type: EventType, arg1: Arg1, arg2: Arg2, arg3?: undefined, arg4?: undefined, arg5?: undefined): void;
    broadcast<Arg1, Arg2, Arg3>(type: EventType, arg1: Arg1, arg2: Arg2, arg3: Arg3, arg4?: undefined, arg5?: undefined): void;
    broadcast<Arg1, Arg2, Arg3, Arg4>(type: EventType, arg1: Arg1, arg2: Arg2, arg3: Arg3, arg4: Arg4, arg5?: undefined): void;
    private _execute;
    private _executeMain;
}
